footlucker/footlucker/Controllers/AdminController.cs
using System.Collections.Generic;
using System.Linq;
using footlucker.Data;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;

namespace footlucker.Controllers
{
    public class AdminController : Controller
    {
        private readonly ProjectContext _context;

        public AdminController(ProjectContext context)
        {
            _context = context;
        }

        public IActionResult Index()
        {
            if (!IsAuthorized())
            {
                return Unauthorized();
            }
            ViewData["Title"] = "דף מנהל";
            return View();
        }

        [HttpGet]
        public JsonResult BranchSales()
        {
            if (!IsAuthorized())
            {
                var res = Json("you are not autorized for this request");
                res.StatusCode = 401;
                return res;
            }
            var result = _context.Purchases.Join(_context.Branches,
                (purchase => purchase.Branch.Id),
                (branch => branch.Id),
                (p, b) => new
                {
                    branchId = b.Id,
                    branchName = b.Name,
                    count = p.Count
                })
            .AsEnumerable()
            .GroupBy(b => b.branchId)
            .Select(p => new
            {
                Count = p.Sum(pur => pur.count),
                Name = p.First(pur => pur.branchId == p.Key).branchName,
                Id = p.Key
            });

            return Json(result);
        }

        [HttpGet]
        public JsonResult ProductSales()
        {
            if (!IsAuthorized())
            {
                var res = Json("you are not autorized for this request");
                res.StatusCode = 401;
                return res;
            }
            var result = _context.Purchases.Join(_context.Products,
                (purchase => purchase.Product.Id),
                (product => product.Id),
                (pur, pro) => new
                {
                    ProductTypeId = pro.ProductTypeId,
                    productName = pro.ProductType.Name,
                    count = pur.Count
                })
            .AsEnumerable()
            .GroupBy(b => b.ProductTypeId)
            .Select(p => new
            {
                Count = p.Sum(pur => pur.count),
                Name = p.First(pur => pur.ProductTypeId == p.Key).productName,
                Id = p.Key
            });
            return Json(result);
        }

        private bool IsAuthorized()
        {
            return (HttpContext.Session.GetString("isAdmin") == "true" ? true : false) &&
                (HttpContext.Session.GetString("isLogin") == "true" ? true : false);
        }
    }
}

footlucker/footlucker/Controllers/BranchesController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using footlucker.Data;
using footlucker.Models;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Microsoft.EntityFrameworkCore;

namespace footlucker.Controllers
{
    public class BranchesController : Controller
    {
        private readonly ProjectContext _context;

        public BranchesController(ProjectContext context)
        {
            _context = context;
        }

        // GET: Branches
        public async Task<IActionResult> Index(string Name, string City, string Address)
        {
            ViewData["BranchesNameQuery"] = Name;
            ViewData["BranchesCityQuery"] = City;
            ViewData["BranchesAddressQuery"] = Address;

            var branches = _context.Branches.Select(x => x);

            if (!String.IsNullOrEmpty(Name))
            {
                branches = branches.Where(x => x.Name.Contains(Name));
            }

            if (!String.IsNullOrEmpty(City))
            {
                branches = branches.Where(x => x.City.Contains(City));
            }

            if (!String.IsNullOrEmpty(Address))
            {
                branches = branches.Where(x => x.Address.Contains(Address));
            }

            return View(await branches.AsNoTracking().ToListAsync());
        }

        // GET: Branches/Create
        public IActionResult Create()
        {
            if (!IsAuthorized())
            {
                return Unauthorized();
            }
            return View();
        }

        // POST: Branches/Create
        // To protect from overposting attacks, please enable the specific properties you want to bind to, for 
        // more details see http://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Create([Bind("Lat,Long,Name,City,Address,Telephone,IsSaturday,Id")] Branch branch)
        {
            if (!IsAuthorized())
            {
                return Unauthorized();
            }
            if (ModelState.IsValid)
            {
                _context.Add(branch);
                await _context.SaveChangesAsync();
                return RedirectToAction(nameof(Index));
            }
            return BadRequest();
        }

        // GET: Branches/Edit/5
        public async Task<IActionResult> Edit(int? id)
        {
            if (!IsAuthorized())
            {
                return Unauthorized();
            }
            if (id == null)
            {
                return NotFound();
            }

            var branch = await _context.Branches.FindAsync(id);
            if (branch == null)
            {
                return NotFound();
            }
            return View(branch);
        }

        // POST: Branches/Edit/5
        // To protect from overposting attacks, please enable the specific properties you want to bind to, for 
        // more details see http://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Edit(int id, [Bind("Lat,Long,Name,City,Address,Telephone,IsSaturday,Id")] Branch branch)
        {
            if (!IsAuthorized())
            {
                return Unauthorized();
            }
            if (id != branch.Id)
            {
                return NotFound();
            }

            if (ModelState.IsValid)
            {
                try
                {
                    _context.Update(branch);
                    await _context.SaveChangesAsync();
                }
                catch (DbUpdateConcurrencyException)
                {
                    if (!BranchExists(branch.Id))
                    {
                        return NotFound();
                    }
                    else
                    {
                        throw;
                    }
                }
                return RedirectToAction(nameof(Index));
            }
            return BadRequest();
        }

        // GET: Branches/Delete/5
        public async Task<IActionResult> Delete(int? id)
        {
            if (!IsAuthorized())
            {
                return Unauthorized();
            }
            if (id == null)
            {
                return NotFound();
            }

            var branch = await _context.Branches
                .FirstOrDefaultAsync(m => m.Id == id);
            if (branch == null)
            {
                return NotFound();
            }

            return View(branch);
        }

        // POST: Branches/Delete/5
        [HttpPost, ActionName("Delete")]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> DeleteConfirmed(int id)
        {
            if (!IsAuthorized())
            {
                return Unauthorized();
            }
            var branch = await _context.Branches.FindAsync(id);
            if (branch == null)
            {
                return View("Views/Branches/NotFound.cshtml");
            }
            branch.Purchases.ToList().ForEach(p => branch.Purchases.Remove(p));
            _context.Branches.Remove(branch);
            await _context.SaveChangesAsync();
            return RedirectToAction(nameof(Index));
        }

        private bool BranchExists(int id)
        {
            return _context.Branches.Any(e => e.Id == id);
        }

        private bool IsAuthorized()
        {
            return (HttpContext.Session.GetString("isAdmin") == "true" ? true : false) &&
                (HttpContext.Session.GetString("isLogin") == "true" ? true : false);
        }
    }
}

footlucker/footlucker/Controllers/UsersController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;
using Microsoft.EntityFrameworkCore;
using Microsoft.AspNetCore.Http;
using footlucker.Data;
using footlucker.Models;

namespace footlucker.Controllers
{
    public class UsersController : Controller
    {
        private readonly ProjectContext _context;

        public UsersController(ProjectContext context)
        {
            _context = context;
        }

        // GET: Users
        public async Task<IActionResult> Index(string searchString, string filterType)
        {
            if (!IsAuthorized())
            {
                return Unauthorized();
            }
            ViewData["CurrentFilter"] = searchString;
            ViewData["FilterType"] = filterType;
            var isAdmin = HttpContext.Session.GetString("isAdmin") == "true" ? true : false;
            if (!isAdmin)
            {
                return RedirectToAction("Index", "Home", null);
            }
            var users = _context.Users.Select(s => s);
            if (!String.IsNullOrEmpty(searchString))
            {
                switch (filterType)
                {
                    case "שם משתמש":
                        users = users.Where(s => s.Username.Contains(searchString));
                        break;
                    case "סיסמא":
                        users = users.Where(s => s.Password.Contains(searchString));
                        break;
                    case "כתובת":
                        users = users.Where(s => s.Address.Contains(searchString));
                        break;
                }
            }
            return View(await users.AsNoTracking().ToListAsync());
        }

        // GET: Users/Create
        public IActionResult Create()
        {
            if (!IsAuthorized())
            {
                return Unauthorized();
            }
            return View();
        }

        // POST: Users/Create
        // To protect from overposting attacks, please enable the specific properties you want to bind to, for 
        // more details see http://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Create([Bind("Username,Password,Address,Gender,IsAdmin")] User user)
        {
            if (!IsAuthorized())
            {
                return Unauthorized();
            }
            if (ModelState.IsValid)
            {
                if (_context.Users.Any(e => e.Username == user.Username))
                {
                    ViewData["errorMessage"] = "שם משתמש זה קיים כבר במערכת";
                    return View(nameof(Create));
                }
                _context.Add(user);
                await _context.SaveChangesAsync();
                return RedirectToAction(nameof(Index));
            }
            return BadRequest();
        }

        // GET: Users/Register
        public IActionResult Register()
        {
            return View();
        }

        // POST: Users/Register
        // To protect from overposting attacks, please enable the specific properties you want to bind to, for 
        // more details see http://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Register([Bind("Username,Password,Address,Gender,IsAdmin")] User user)
        {
            if (ModelState.IsValid)
            {
                if (_context.Users.Any(e => e.Username == user.Username))
                {
                    ViewData["errorMessage"] = "שם משתמש זה קיים כבר במערכת";
                    return View(nameof(Register));
                }
                _context.Add(user);
                await _context.SaveChangesAsync();
                return await Login(user.Username, user.Password);
            }
            return BadRequest();
        }

        // GET: Users/Edit/5
        public async Task<IActionResult> Edit(int? id)
        {
            if (!IsAuthorized())
            {
                return Unauthorized();
            }
            if (id == null)
            {
                return NotFound();
            }

            var user = await _context.Users.FindAsync(id);
            if (user == null)
            {
                return NotFound();
            }
            return View(user);
        }

        // POST: Users/Edit/5
        // To protect from overposting attacks, please enable the specific properties you want to bind to, for 
        // more details see http://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Edit(int id, [Bind("Username,Password,Address,Gender,Id,IsAdmin")] User user)
        {
            if (!IsAuthorized())
            {
                return Unauthorized();
            }
            if (id != user.Id)
            {
                return NotFound();
            }

            if (ModelState.IsValid)
            {
                try
                {
                    // check if the edit user change it name, and if it did check if there is already Username in the db.
                    if (_context.Users.AsNoTracking().FirstOrDefault(u => u.Id == id).Username != user.Username &&
                        _context.Users.Any(e => e.Username == user.Username))
                    {
                        ViewData["errorMessage"] = "שם משתמש זה קיים כבר במערכת";
                        return View(nameof(Edit));
                    }
                    _context.Update(user);
                    await _context.SaveChangesAsync();
                }
                catch (DbUpdateConcurrencyException)
                {
                    if (!UserExists(user.Id))
                    {
                        return NotFound();
                    }
                    else
                    {
                        throw;
                    }
                }
                return RedirectToAction(nameof(Index));
            }
            return BadRequest();
        }

        // GET: Users/Delete/5
        public async Task<IActionResult> Delete(int? id)
        {
            if (!IsAuthorized())
            {
                return Unauthorized();
            }
            if (id == null)
            {
                return NotFound();
            }

            var user = await _context.Users
                .FirstOrDefaultAsync(m => m.Id == id);
            if (user == null)
            {
                return NotFound();
            }

            return View(user);
        }

        // GET: Users/Login/5
        public async Task<IActionResult> Login(string userName, string password)
        {
            if (userName == null || password == null)
            {
                return View();
            }

            var user = await _context.Users.SingleOrDefaultAsync(u => u.Username == userName && u.Password == password);
            if (user == null)
            {
                return View("Views/Users/NotFound.cshtml");
            }
            HttpContext.Session.SetString("isAdmin", user.IsAdmin ? "true" : "false");
            HttpContext.Session.SetString("username", user.Username);
            HttpContext.Session.SetString("userid", user.Id.ToString());
            HttpContext.Session.SetString("isLogin", "true");

            if (user.IsAdmin)
            {
                return RedirectToAction("Index", null);
            }
            return RedirectToAction("Index", "Home", null);
        }

        [HttpGet]
        public IActionResult Logout()
        {
            HttpContext.Session.SetString("isAdmin", "false");
            HttpContext.Session.SetString("username", "");
            HttpContext.Session.SetString("userid", "-1");
            HttpContext.Session.SetString("isLogin", "false");

            return RedirectToAction("Index", "Home", null);
        }

        // POST: Users/Delete/5
        [HttpPost, ActionName("Delete")]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> DeleteConfirmed(int id)
        {
            if (!IsAuthorized())
            {
                return Unauthorized();
            }
            var user = await _context.Users.FindAsync(id);
            if (user == null)
            {
                return View("Views/Users/NotFound.cshtml");
            }
            _context.Users.Remove(user);
            await _context.SaveChangesAsync();
            return RedirectToAction(nameof(Index));
        }

        private bool UserExists(int id)
        {
            return _context.Users.Any(e => e.Id == id);
        }

        private bool IsAuthorized()
        {
            return (HttpContext.Session.GetString("isAdmin") == "true" ? true : false) &&
                (HttpContext.Session.GetString("isLogin") == "true" ? true : false);
        }
    }
}

footlucker/footlucker/Views/Shared/_Layout.cshtml
@using Microsoft.AspNetCore.Http;

@{
    var isAdmin = Context.Session.GetString("isAdmin") == "true" ? true : false;
    var userName = Context.Session.GetString("username");
    var isLogin = Context.Session.GetString("isLogin") == "true" ? true : false;
}
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@ViewData["Title"] - footlucker</title>

    <environment include="Development">
        <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.css" />
        <link rel="stylesheet" href="~/css/site.css" />
        <link rel="stylesheet" href="~/css/globals.css" />
        <link rel="stylesheet" href="~/css/Branches.css" />
        <link rel="stylesheet" href="~/css/home.css" />
        <link rel="stylesheet" href="~/css/admin.css" />
        <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Roboto">
    </environment>
</head>
<body dir="rtl">
    <nav class="navbar-inverse navbar-fixed-top navbar_override">
        <div class="container">
            <div class="navbar-header" style="float:right">
                <button type="button" class="navbar-toggle" data-toggle="collapse" data-target=".navbar-collapse">
                    <span class="sr-only">Toggle navigation</span>
                    <span class="icon-bar"></span>
                    <span class="icon-bar"></span>
                    <span class="icon-bar"></span>
                </button>
                <a asp-area="" asp-controller="Home" asp-action="Index" class="navbar-brand"><img class="footluckerImage" src="~/images/footlucker.png" /></a>
            </div>
            <div class="navbar-collapse collapse" style="float:right">

                <ul class="nav navbar-nav">
                    @{
                        if (isAdmin)
                        {
                            <li><a asp-area="" asp-controller="Users" asp-action="Index">משתמשים</a></li>
                            <li><a asp-area="" asp-controller="Admin" asp-action="Index">ניהול</a></li>
                        }
                    }
                    <li><a asp-area="" asp-controller="Suppliers" asp-action="Index">ספקים</a></li>
                    <li><a asp-area="" asp-controller="Products" asp-action="Index">מוצרים</a></li>
                    <li><a asp-area="" asp-controller="Branches" asp-action="Index">סניפים</a></li>
                </ul>

            </div>
            <div class="navbar-collapse collapse" style="float:left">
                @{
                    if (isLogin)
                    {
                        <ul class="nav navbar-nav">
                            <li><a asp-area="" asp-controller="Users" asp-action="Logout">התנתק</a></li>
                        </ul>
                        <span class="navbar-text">
                            @("שלום, " + userName)
                        </span>
                    }
                    else
                    {
                        <ul class="nav navbar-nav">
                            <li><a asp-area="" asp-controller="Users" asp-action="Login">התחבר</a></li>
                        </ul>
                        <span class="navbar-text">
                            @("שלום, אורח")
                        </span>
                    }
                }
            </div>
        </div>
    </nav>

    <div class="body-content">

        @RenderBody()

    </div>

    <environment include="Development">
        <script src="~/lib/jquery/dist/jquery.js"></script>
        <script src="~/lib/bootstrap/dist/js/bootstrap.js"></script>
        <script src="~/js/site.js" asp-append-version="true"></script>
    </environment>
    <environment exclude="Development">
        <script src="https://ajax.aspnetcdn.com/ajax/jquery/jquery-3.3.1.min.js"
                asp-fallback-src="~/lib/jquery/dist/jquery.min.js"
                asp-fallback-test="window.jQuery"
                crossorigin="anonymous"
                integrity="sha384-tsQFqpEReu7ZLhBV2VZlAu7zcOV+rXbYlF2cqB8txI/8aZajjp4Bqd+V6D5IgvKT">
        </script>
        <script src="https://ajax.aspnetcdn.com/ajax/bootstrap/3.3.7/bootstrap.min.js"
                asp-fallback-src="~/lib/bootstrap/dist/js/bootstrap.min.js"
                asp-fallback-test="window.jQuery && window.jQuery.fn && window.jQuery.fn.modal"
                crossorigin="anonymous"
                integrity="sha384-Tc5IQib027qvyjSMfHjOMaLkfuWVxZxUPnCJA7l2mCWNIpG9mGCD8wGNIcPD7Txa">
        </script>
        <script src="~/js/site.min.js" asp-append-version="true"></script>
    </environment>

    @RenderSection("Scripts", required: false)
</body>
</html>